part of masamune;

class _NavigatorControllerHookCreator {
  const _NavigatorControllerHookCreator();
  NavigatorController call() {
    return use(const _NavigatorControllerHook());
  }
}

const useNavigatorController = _NavigatorControllerHookCreator();

class _NavigatorControllerHook extends Hook<NavigatorController> {
  const _NavigatorControllerHook();

  @override
  _NavigatorControllerHookState createState() {
    return _NavigatorControllerHookState();
  }
}

class _NavigatorControllerHookState
    extends HookState<NavigatorController, _NavigatorControllerHook> {
  final _controller = NavigatorController();
  @override
  void initHook() {
    super.initHook();
    _controller.addListener(_handleOnUpdate);
  }

  @override
  void dispose() {
    super.dispose();
    _controller.removeListener(_handleOnUpdate);
  }

  @override
  NavigatorController build(BuildContext context) => _controller;

  void _handleOnUpdate() {
    setState(() {});
  }

  @override
  String get debugLabel => 'useNavigatorController';
}
